/*
 * generated by Xtext 2.32.0
 */
package no.hal.quiz.xtext.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import no.hal.quiz.xtext.ide.contentassist.antlr.internal.InternalQuizDSLParser;
import no.hal.quiz.xtext.services.QuizDSLGrammarAccess;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class QuizDSLParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(QuizDSLGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, QuizDSLGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getQuizAccess().getAlternatives_2(), "rule__Quiz__Alternatives_2");
			builder.put(grammarAccess.getAbstractQuizPartAccess().getAlternatives(), "rule__AbstractQuizPart__Alternatives");
			builder.put(grammarAccess.getAbstractQAAccess().getAlternatives(), "rule__AbstractQA__Alternatives");
			builder.put(grammarAccess.getQuestionAccess().getAlternatives(), "rule__Question__Alternatives");
			builder.put(grammarAccess.getAnswerAccess().getAlternatives(), "rule__Answer__Alternatives");
			builder.put(grammarAccess.getOptionAnswerAccess().getAlternatives(), "rule__OptionAnswer__Alternatives");
			builder.put(grammarAccess.getSimpleAnswerAccess().getAlternatives(), "rule__SimpleAnswer__Alternatives");
			builder.put(grammarAccess.getBooleanAnswerAccess().getAlternatives_1(), "rule__BooleanAnswer__Alternatives_1");
			builder.put(grammarAccess.getBooleanAnswerAccess().getValueAlternatives_1_0_0(), "rule__BooleanAnswer__ValueAlternatives_1_0_0");
			builder.put(grammarAccess.getBooleanAnswerAccess().getAlternatives_1_1(), "rule__BooleanAnswer__Alternatives_1_1");
			builder.put(grammarAccess.getOptionsAnswerAccess().getAlternatives(), "rule__OptionsAnswer__Alternatives");
			builder.put(grammarAccess.getSingleOptionsAnswerAccess().getAlternatives(), "rule__SingleOptionsAnswer__Alternatives");
			builder.put(grammarAccess.getSingleListOptionAccess().getAlternatives_0(), "rule__SingleListOption__Alternatives_0");
			builder.put(grammarAccess.getSingleListOptionAccess().getAlternatives_0_0(), "rule__SingleListOption__Alternatives_0_0");
			builder.put(grammarAccess.getXmlElementAccess().getAlternatives(), "rule__XmlElement__Alternatives");
			builder.put(grammarAccess.getXmlTagElementAccess().getAlternatives_1(), "rule__XmlTagElement__Alternatives_1");
			builder.put(grammarAccess.getQuizAccess().getGroup(), "rule__Quiz__Group__0");
			builder.put(grammarAccess.getQuizAccess().getGroup_2_0(), "rule__Quiz__Group_2_0__0");
			builder.put(grammarAccess.getQNameAccess().getGroup(), "rule__QName__Group__0");
			builder.put(grammarAccess.getQNameAccess().getGroup_1(), "rule__QName__Group_1__0");
			builder.put(grammarAccess.getQuizPartAccess().getGroup(), "rule__QuizPart__Group__0");
			builder.put(grammarAccess.getQuizPartRefAccess().getGroup(), "rule__QuizPartRef__Group__0");
			builder.put(grammarAccess.getAnonymousQuizPartAccess().getGroup(), "rule__AnonymousQuizPart__Group__0");
			builder.put(grammarAccess.getQARefAccess().getGroup(), "rule__QARef__Group__0");
			builder.put(grammarAccess.getQAAccess().getGroup(), "rule__QA__Group__0");
			builder.put(grammarAccess.getStringAnswerAccess().getGroup(), "rule__StringAnswer__Group__0");
			builder.put(grammarAccess.getRegexAnswerAccess().getGroup(), "rule__RegexAnswer__Group__0");
			builder.put(grammarAccess.getNumberAnswerAccess().getGroup(), "rule__NumberAnswer__Group__0");
			builder.put(grammarAccess.getNumberAnswerAccess().getGroup_1(), "rule__NumberAnswer__Group_1__0");
			builder.put(grammarAccess.getEDoubleObjectAccess().getGroup(), "rule__EDoubleObject__Group__0");
			builder.put(grammarAccess.getEDoubleObjectAccess().getGroup_1(), "rule__EDoubleObject__Group_1__0");
			builder.put(grammarAccess.getBooleanAnswerAccess().getGroup(), "rule__BooleanAnswer__Group__0");
			builder.put(grammarAccess.getSingleBoxOptionAccess().getGroup(), "rule__SingleBoxOption__Group__0");
			builder.put(grammarAccess.getSingleListOptionAccess().getGroup(), "rule__SingleListOption__Group__0");
			builder.put(grammarAccess.getManyOptionAccess().getGroup(), "rule__ManyOption__Group__0");
			builder.put(grammarAccess.getXmlAccess().getGroup(), "rule__Xml__Group__0");
			builder.put(grammarAccess.getXmlContentsAccess().getGroup(), "rule__XmlContents__Group__0");
			builder.put(grammarAccess.getXmlPIAnswerElementAccess().getGroup(), "rule__XmlPIAnswerElement__Group__0");
			builder.put(grammarAccess.getXmlTagElementAccess().getGroup(), "rule__XmlTagElement__Group__0");
			builder.put(grammarAccess.getXmlTagElementAccess().getGroup_1_1(), "rule__XmlTagElement__Group_1_1__0");
			builder.put(grammarAccess.getXmlTagElementAccess().getGroup_1_1_2(), "rule__XmlTagElement__Group_1_1_2__0");
			builder.put(grammarAccess.getXmlTagAccess().getGroup(), "rule__XmlTag__Group__0");
			builder.put(grammarAccess.getXmlAttributeAccess().getGroup(), "rule__XmlAttribute__Group__0");
			builder.put(grammarAccess.getQuizAccess().getNameAssignment_2_0_0(), "rule__Quiz__NameAssignment_2_0_0");
			builder.put(grammarAccess.getQuizAccess().getTitleAssignment_2_0_1(), "rule__Quiz__TitleAssignment_2_0_1");
			builder.put(grammarAccess.getQuizAccess().getPartsAssignment_2_0_2(), "rule__Quiz__PartsAssignment_2_0_2");
			builder.put(grammarAccess.getQuizAccess().getPartsAssignment_2_1(), "rule__Quiz__PartsAssignment_2_1");
			builder.put(grammarAccess.getQuizPartAccess().getNameAssignment_1(), "rule__QuizPart__NameAssignment_1");
			builder.put(grammarAccess.getQuizPartAccess().getTitleAssignment_2(), "rule__QuizPart__TitleAssignment_2");
			builder.put(grammarAccess.getQuizPartAccess().getQuestionsAssignment_3(), "rule__QuizPart__QuestionsAssignment_3");
			builder.put(grammarAccess.getQuizPartRefAccess().getPartRefAssignment_2(), "rule__QuizPartRef__PartRefAssignment_2");
			builder.put(grammarAccess.getAnonymousQuizPartAccess().getQuestionsAssignment_1(), "rule__AnonymousQuizPart__QuestionsAssignment_1");
			builder.put(grammarAccess.getQARefAccess().getQaRefAssignment_1(), "rule__QARef__QaRefAssignment_1");
			builder.put(grammarAccess.getQAAccess().getNameAssignment_0(), "rule__QA__NameAssignment_0");
			builder.put(grammarAccess.getQAAccess().getQAssignment_1(), "rule__QA__QAssignment_1");
			builder.put(grammarAccess.getQAAccess().getAAssignment_2(), "rule__QA__AAssignment_2");
			builder.put(grammarAccess.getStringQuestionAccess().getQuestionAssignment(), "rule__StringQuestion__QuestionAssignment");
			builder.put(grammarAccess.getXmlQuestionAccess().getXmlAssignment(), "rule__XmlQuestion__XmlAssignment");
			builder.put(grammarAccess.getStringAnswerAccess().getValueAssignment_0(), "rule__StringAnswer__ValueAssignment_0");
			builder.put(grammarAccess.getStringAnswerAccess().getIgnoreCaseAssignment_1(), "rule__StringAnswer__IgnoreCaseAssignment_1");
			builder.put(grammarAccess.getRegexAnswerAccess().getRegexpAssignment_0(), "rule__RegexAnswer__RegexpAssignment_0");
			builder.put(grammarAccess.getRegexAnswerAccess().getValueAssignment_1(), "rule__RegexAnswer__ValueAssignment_1");
			builder.put(grammarAccess.getRegexAnswerAccess().getIgnoreCaseAssignment_3(), "rule__RegexAnswer__IgnoreCaseAssignment_3");
			builder.put(grammarAccess.getNumberAnswerAccess().getValueAssignment_0(), "rule__NumberAnswer__ValueAssignment_0");
			builder.put(grammarAccess.getNumberAnswerAccess().getErrorMarginAssignment_1_1(), "rule__NumberAnswer__ErrorMarginAssignment_1_1");
			builder.put(grammarAccess.getBooleanAnswerAccess().getValueAssignment_1_0(), "rule__BooleanAnswer__ValueAssignment_1_0");
			builder.put(grammarAccess.getXmlAnswerAccess().getXmlAssignment(), "rule__XmlAnswer__XmlAssignment");
			builder.put(grammarAccess.getSingleBoxOptionsAnswerAccess().getOptionsAssignment(), "rule__SingleBoxOptionsAnswer__OptionsAssignment");
			builder.put(grammarAccess.getSingleBoxOptionAccess().getCorrectAssignment_1(), "rule__SingleBoxOption__CorrectAssignment_1");
			builder.put(grammarAccess.getSingleBoxOptionAccess().getOptionAssignment_3(), "rule__SingleBoxOption__OptionAssignment_3");
			builder.put(grammarAccess.getSingleListOptionsAnswerAccess().getOptionsAssignment(), "rule__SingleListOptionsAnswer__OptionsAssignment");
			builder.put(grammarAccess.getSingleListOptionAccess().getCorrectAssignment_0_1(), "rule__SingleListOption__CorrectAssignment_0_1");
			builder.put(grammarAccess.getSingleListOptionAccess().getOptionAssignment_1(), "rule__SingleListOption__OptionAssignment_1");
			builder.put(grammarAccess.getManyOptionsAnswerAccess().getOptionsAssignment(), "rule__ManyOptionsAnswer__OptionsAssignment");
			builder.put(grammarAccess.getManyOptionAccess().getCorrectAssignment_1(), "rule__ManyOption__CorrectAssignment_1");
			builder.put(grammarAccess.getManyOptionAccess().getOptionAssignment_3(), "rule__ManyOption__OptionAssignment_3");
			builder.put(grammarAccess.getXmlAccess().getElementAssignment_1(), "rule__Xml__ElementAssignment_1");
			builder.put(grammarAccess.getXmlContentsAccess().getElementAssignment_0(), "rule__XmlContents__ElementAssignment_0");
			builder.put(grammarAccess.getXmlContentsAccess().getPostAssignment_1(), "rule__XmlContents__PostAssignment_1");
			builder.put(grammarAccess.getXmlPIAnswerElementAccess().getAnswerAssignment_1(), "rule__XmlPIAnswerElement__AnswerAssignment_1");
			builder.put(grammarAccess.getXmlTagElementAccess().getStartTagAssignment_0(), "rule__XmlTagElement__StartTagAssignment_0");
			builder.put(grammarAccess.getXmlTagElementAccess().getPreAssignment_1_1_0(), "rule__XmlTagElement__PreAssignment_1_1_0");
			builder.put(grammarAccess.getXmlTagElementAccess().getContentsAssignment_1_1_1(), "rule__XmlTagElement__ContentsAssignment_1_1_1");
			builder.put(grammarAccess.getXmlTagElementAccess().getEndTagAssignment_1_1_2_1(), "rule__XmlTagElement__EndTagAssignment_1_1_2_1");
			builder.put(grammarAccess.getXmlTagAccess().getNameAssignment_0(), "rule__XmlTag__NameAssignment_0");
			builder.put(grammarAccess.getXmlTagAccess().getAttributesAssignment_1(), "rule__XmlTag__AttributesAssignment_1");
			builder.put(grammarAccess.getXmlAttributeAccess().getNameAssignment_0(), "rule__XmlAttribute__NameAssignment_0");
			builder.put(grammarAccess.getXmlAttributeAccess().getValueAssignment_2(), "rule__XmlAttribute__ValueAssignment_2");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private QuizDSLGrammarAccess grammarAccess;

	@Override
	protected InternalQuizDSLParser createParser() {
		InternalQuizDSLParser result = new InternalQuizDSLParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public QuizDSLGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(QuizDSLGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
